ngram_search.c File Reference
`#include <string.h>`
`#include <assert.h>`
`#include <sphinxbase/ckd_alloc.h>`
`#include <sphinxbase/listelem_alloc.h>`
`#include <sphinxbase/err.h>`
`#include "pocketsphinx_internal.h"`
`#include "ps_lattice_internal.h"`
`#include "ngram_search.h"`
`#include "ngram_search_fwdtree.h"`
`#include "ngram_search_fwdflat.h"`

Go to the source code of this file.

## Macros

#define | NGRAM_HISTORY_LONG_WORD 2000 /* 20s */

## Functions

ps_search_t * | ngram_search_init (const char *name, ngram_model_t *lm, cmd_ln_t *config, acmod_t *acmod, dict_t *dict, dict2pid_t *d2p)
| Initialize the N-Gram search module.
void | ngram_search_free (ps_search_t *search)
| Finalize the N-Gram search module.
int | ngram_search_mark_bptable (ngram_search_t *ngs, int frame_idx)
| Record the current frame's index in the backpointer table. More...
void | ngram_search_save_bp (ngram_search_t *ngs, int frame_idx, int32 w, int32 score, int32 path, int32 rc)
| Enter a word in the backpointer table.
int | ngram_search_find_exit (ngram_search_t *ngs, int frame_idx, int32 *out_best_score)
| Find the best word exit for the current frame in the backpointer table. More...
const char * | ngram_search_bp_hyp (ngram_search_t *ngs, int bpidx)
| Backtrace from a given backpointer index to obtain a word hypothesis. More...
void | ngram_search_alloc_all_rc (ngram_search_t *ngs, int32 w)
| Allocate last phone channels for all possible right contexts for word w.
void | ngram_search_free_all_rc (ngram_search_t *ngs, int32 w)
| Allocate last phone channels for all possible right contexts for word w.
int32 | ngram_search_exit_score (ngram_search_t *ngs, bptbl_t *pbe, int rcphone)
| Get the exit score for a backpointer entry with a given right context.
void | ngram_compute_seg_score (ngram_search_t *ngs, bptbl_t *be, float32 lwf, int32 *out_ascr, int32 *out_lscr)
void | dump_bptable (ngram_search_t *ngs)
ps_lattice_t * | ngram_search_lattice (ps_search_t *search)
| Construct a word lattice from the current hypothesis.
void | ngram_search_set_lm (ngram_model_t *lm)
| Sets the global language model. More...

## Detailed Description

N-Gram based multi-pass search ("FBS")

Definition in file ngram_search.c.

## Function Documentation

## ngram_search_bp_hyp()

const char* ngram_search_bp_hyp | ( | ngram_search_t * | ngs,
|  | int | bpidx
| ) |  |

Backtrace from a given backpointer index to obtain a word hypothesis.

Returns
  a read-only string with the best hypothesis.

Definition at line 550 of file ngram_search.c.

## ngram_search_find_exit()

int ngram_search_find_exit | ( | ngram_search_t * | ngs,
|  | int | frame_idx,
|  | int32 * | out_best_score
| ) |  |

Find the best word exit for the current frame in the backpointer table.

Returns
  the backpointer index of the best word exit.

Definition at line 506 of file ngram_search.c.

References ngram_search_s::n_frame.

## ngram_search_mark_bptable()

int ngram_search_mark_bptable | ( | ngram_search_t * | ngs,
|  | int | frame_idx
| ) |  |

Record the current frame's index in the backpointer table.

Returns
  the current backpointer index.

Definition at line 329 of file ngram_search.c.

References ngram_search_s::frm_wordlist, and ngram_search_s::n_frame_alloc.

## ngram_search_set_lm()

void ngram_search_set_lm | ( | ngram_model_t * | lm | ) |

Sets the global language model.

Sets the language model to use if nothing was passed in configuration

Definition at line 1403 of file ngram_search.c.